//+------------------------------------------------------------------+
//|                                                      #MTF SR.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 DarkBlue
#property indicator_color4 Maroon
#property indicator_color5 Blue
#property indicator_color6 Red
#property indicator_color7 PowderBlue
#property indicator_color8 LightPink

//
//
//
//
//

extern string timeFrames       = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-currentTF";
extern int    Period_1         = 5;
extern int    Period_2         = 15;
extern int    Period_3         = 30;
extern int    Period_4         = 720;
extern bool   display_Period_1 = false;
extern bool   display_Period_2 = false;
extern bool   display_Period_3 = false;
extern bool   display_Period_4 = true;

//
//
//
//
//

double buf_up1D[];
double buf_down1D[];
double buf_up4H[];
double buf_down4H[];
double buf_up1H[];
double buf_down1H[];
double buf_up30M[];
double buf_down30M[];

//
//
//
//
//

extern bool alertsOn        = true;
extern int  alertsUsePrice  = PRICE_CLOSE;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

//
//
//
//
//

bool   returnBars;
string indicatorFileName;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   if (Period_1 < Period()) display_Period_1 = false;
   if (Period_2 < Period()) display_Period_2 = false;
   if (Period_3 < Period()) display_Period_3 = false;
   if (Period_4 < Period()) display_Period_4 = false;
   if (!display_Period_1 &&
       !display_Period_2 &&
       !display_Period_3 &&
       !display_Period_4)
       {
         Period_1=Period(); display_Period_1 = true;
       }
                
   //
   //
   //
   //
   //
   
   int draw;
   draw = DRAW_ARROW; if (!display_Period_4) draw = DRAW_NONE;
      SetIndexBuffer(0,buf_up1D);    SetIndexLabel(0,"S "+tf2txt(Period_4)); SetIndexStyle(0,draw); SetIndexArrow(0,167); SetIndexEmptyValue(0,0);
      SetIndexBuffer(1,buf_down1D);  SetIndexLabel(1,"R "+tf2txt(Period_4)); SetIndexStyle(1,draw); SetIndexArrow(1,167); SetIndexEmptyValue(1,0);
   draw = DRAW_ARROW; if (!display_Period_3) draw = DRAW_NONE;
      SetIndexBuffer(2,buf_up4H);    SetIndexLabel(2,"S "+tf2txt(Period_3)); SetIndexStyle(2,draw); SetIndexArrow(2,167); SetIndexEmptyValue(2,0);
      SetIndexBuffer(3,buf_down4H);  SetIndexLabel(3,"R "+tf2txt(Period_3)); SetIndexStyle(3,draw); SetIndexArrow(3,167); SetIndexEmptyValue(3,0);
   draw = DRAW_ARROW; if (!display_Period_2) draw = DRAW_NONE;
      SetIndexBuffer(4,buf_up1H);    SetIndexLabel(4,"S "+tf2txt(Period_2)); SetIndexStyle(4,draw); SetIndexArrow(4,167); SetIndexEmptyValue(4,0);
      SetIndexBuffer(5,buf_down1H);  SetIndexLabel(5,"R "+tf2txt(Period_2)); SetIndexStyle(5,draw); SetIndexArrow(5,167); SetIndexEmptyValue(5,0);
   draw = DRAW_ARROW; if (!display_Period_1) draw = DRAW_NONE;
      SetIndexBuffer(6,buf_up30M);   SetIndexLabel(6,"S "+tf2txt(Period_1)); SetIndexStyle(6,draw); SetIndexArrow(6,167); SetIndexEmptyValue(6,0);
      SetIndexBuffer(7,buf_down30M); SetIndexLabel(7,"R "+tf2txt(Period_1)); SetIndexStyle(7,draw); SetIndexArrow(7,167); SetIndexEmptyValue(7,0);

   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   returnBars        = (timeFrames=="returnBars"); 
   return(0);
}
int deinit() { return(0); }

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double trends[][8];
double alertTimes[8];
string alertMessages[8];

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
   int limit=MathMin(Bars-counted_bars+3,Bars-1);

      if (returnBars) { buf_up1D[0] = limit+1; return(0); }
      if (ArrayRange(trends,0) != Bars) ArrayResize(trends,Bars);
   
      //
      //
      //
      //
      //
      
      limit = MathMax(limit,iCustom(NULL,Period_4,indicatorFileName,"returnBars",0,0)*Period_4/Period());
      limit = MathMax(limit,iCustom(NULL,Period_3,indicatorFileName,"returnBars",0,0)*Period_3/Period());
      limit = MathMax(limit,iCustom(NULL,Period_2,indicatorFileName,"returnBars",0,0)*Period_2/Period());
      limit = MathMax(limit,iCustom(NULL,Period_1,indicatorFileName,"returnBars",0,0)*Period_1/Period());
      limit = MathMin(Bars-1,limit);

   //
   //
   //
   //
   //
         
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int y1d  = iBarShift(NULL,Period_4,Time[i]);
      int y4h  = iBarShift(NULL,Period_3,Time[i]);
      int y1h  = iBarShift(NULL,Period_2,Time[i]);
      int y30m = iBarShift(NULL,Period_1,Time[i]);
      
         buf_up1D[i]    = iFractals( NULL, Period_4, MODE_HIGH, y1d);  if (buf_up1D[i]    == 0) buf_up1D[i]    = buf_up1D[i+1];
         buf_down1D[i]  = iFractals( NULL, Period_4, MODE_LOW,  y1d);  if (buf_down1D[i]  == 0) buf_down1D[i]  = buf_down1D[i+1];
         buf_up4H[i]    = iFractals( NULL, Period_3, MODE_HIGH, y4h);  if (buf_up4H[i]    == 0) buf_up4H[i]    = buf_up4H[i+1];
         buf_down4H[i]  = iFractals( NULL, Period_3, MODE_LOW,  y4h);  if (buf_down4H[i]  == 0) buf_down4H[i]  = buf_down4H[i+1];
         buf_up1H[i]    = iFractals( NULL, Period_2, MODE_HIGH, y1h);  if (buf_up1H[i]    == 0) buf_up1H[i]    = buf_up1H[i+1];
         buf_down1H[i]  = iFractals( NULL, Period_2, MODE_LOW,  y1h);  if (buf_down1H[i]  == 0) buf_down1H[i]  = buf_down1H[i+1];
         buf_up30M[i]   = iFractals( NULL, Period_1, MODE_HIGH, y30m); if (buf_up30M[i]   == 0) buf_up30M[i]   = buf_up30M[i+1];
         buf_down30M[i] = iFractals( NULL, Period_1, MODE_LOW,  y30m); if (buf_down30M[i] == 0) buf_down30M[i] = buf_down30M[i+1];

      //
      //
      //
      //
      //
           
      trends[r][0] = trends[r-1][0];
      trends[r][1] = trends[r-1][1];
      trends[r][2] = trends[r-1][2];
      trends[r][3] = trends[r-1][3];
      trends[r][4] = trends[r-1][4];
      trends[r][5] = trends[r-1][5];
      trends[r][6] = trends[r-1][6];
      trends[r][7] = trends[r-1][7];

         double price = iMA(NULL,0,1,0,MODE_SMA,alertsUsePrice,i);
            if (price > buf_up30M[i])   trends[r][0] =  1;
            if (price < buf_up30M[i])   trends[r][0] = -1;
            if (price > buf_down30M[i]) trends[r][1] =  1;
            if (price < buf_down30M[i]) trends[r][1] = -1;
            
            if (price > buf_up1H[i])    trends[r][2] =  1;
            if (price < buf_up1H[i])    trends[r][2] = -1;
            if (price > buf_down1H[i])  trends[r][3] =  1;
            if (price < buf_down1H[i])  trends[r][3] = -1;
            
            if (price > buf_up4H[i])    trends[r][4] =  1;
            if (price < buf_up4H[i])    trends[r][4] = -1;
            if (price > buf_down4H[i])  trends[r][5] =  1;
            if (price < buf_down4H[i])  trends[r][5] = -1;
            
            if (price > buf_up1D[i])    trends[r][6] =  1;
            if (price < buf_up1D[i])    trends[r][6] = -1;
            if (price > buf_down1D[i])  trends[r][7] =  1;
            if (price < buf_down1D[i])  trends[r][7] = -1;
   }

   //
   //
   //
   //
   //
   
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int forBar = 0;
      else     forBar = 1; int whichBar=Bars-forBar-1;

      if (display_Period_1) { checkAlert(whichBar,forBar,0,Period_1,buf_up30M); checkAlert(whichBar,forBar,1,Period_1,buf_down30M); }         
      if (display_Period_2) { checkAlert(whichBar,forBar,2,Period_2,buf_up1H);  checkAlert(whichBar,forBar,3,Period_2,buf_down1H);  }         
      if (display_Period_3) { checkAlert(whichBar,forBar,4,Period_3,buf_up4H);  checkAlert(whichBar,forBar,5,Period_3,buf_down4H);  }         
      if (display_Period_4) { checkAlert(whichBar,forBar,6,Period_4,buf_up1D);  checkAlert(whichBar,forBar,7,Period_4,buf_down1D);  }         
   }

   //
   //
   //
   //
   //
   
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void checkAlert(int whichBar, int forBar, int forAlert, int period, double &array[])
{
   if (trends[whichBar][forAlert]!= trends[whichBar-1][forAlert])
   {
      if (trends[whichBar][forAlert] ==  1) doAlert(whichBar,forAlert,tf2txt(period)+" level "+DoubleToStr(array[forBar],Digits)  +"  up");
      if (trends[whichBar][forAlert] == -1) doAlert(whichBar,forAlert,tf2txt(period)+" level "+DoubleToStr(array[forBar],Digits)+"  down");
   }         
}

//
//
//
//
//

void doAlert(int forBar, int forAlert, string doWhat)
{
   string message;
   
   if (alertMessages[forAlert] != doWhat || alertTimes[forAlert] != Time[forBar])
   {
       alertMessages[forAlert]  = doWhat;
       alertTimes[forAlert]     = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MTF SR ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"MTF SR"),message);
          if (alertsSound)   PlaySound("alert.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//

string tf2txt(int tf)
{
   if (tf == 0)          return("CurrentTF");
   if (tf == PERIOD_M1)  return("M1");
   if (tf == PERIOD_M5)  return("M5");
   if (tf == PERIOD_M15) return("M15");
   if (tf == PERIOD_M30) return("M30");
   if (tf == PERIOD_H1)  return("H1");
   if (tf == PERIOD_H4)  return("H4");
   if (tf == PERIOD_D1)  return("D1");
   if (tf == PERIOD_W1)  return("W1");
   if (tf == PERIOD_MN1) return("MN1");
   return("??");
}